<template>
  <q-card :square="!isDesktopPlatform">
    <q-card-section v-if="loading">
      <div
        class="row flex-center"
      >
        <q-spinner-dots
          color="primary"
          size="24px"
        />
      </div>
    </q-card-section>

    <q-list
      v-if="soilSites && soilSites.length > 0"
      separator
    >
      <q-item
        v-for="soilSite in soilSites"
        :key="soilSite.id"
        clickable
        v-ripple
        @click="onEditSoilSite(soilSite)"
      >
        <q-item-section
          side
        >
          <q-icon
            name="las la-file-alt"
            size="md"
            color="dark"
          />
        </q-item-section>

        <q-item-section class="text-body2">
          <q-item-label lines="1">
            {{ soilSite.label || displayDateTime(soilSite.validFrom) }}
          </q-item-label>
          <q-item-label
            v-if="soilSite.label"
            lines="1"
            caption
          >
            {{ displayDateTime(soilSite.validFrom) }}
          </q-item-label>
        </q-item-section>

        <q-item-section
          side
          top
        >
          <q-icon
            name="las la-angle-right"
            class="q-mt-auto q-mb-auto"
          />
        </q-item-section>
      </q-item>
    </q-list>

    <q-card-section
      v-else
      class="text-body2 text-grey"
    >
      <translate>No soil samples</translate>
    </q-card-section>

    <q-card-actions
      align="right"
    >
      <q-btn
        outline
        color="primary"
        class="q-mr-sm q-mb-sm"
        @click="onNewSoilSite"
      >
        <translate>
          New soil sample
        </translate>
      </q-btn>
    </q-card-actions>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import querySoilSites from 'src/pages/holding-campaign/soil-site/graphql/querySoilSites'

export default {
  name: 'SoilSitesCard',
  mixins: [
    PlatformMixin,
    DateMixin
  ],
  props: {
    plotId: {
      type: Number,
      default: null
    },
    plotGeometry: {
      type: Object,
      default: null
    }
  },
  apollo: {
    soilSites: {
      query: querySoilSites,
      notifyOnNetworkStatusChange: true,
      variables () {
        const whereClause = {
          holding: {
            holding_campaigns: {
              id: {
                _eq: this.$store.state.fastplatform.holdingCampaign.id
              }
            }
          }
        }
        if (this.plotId != null) {
          whereClause.holding = {
            holding_campaigns: {
              sites: {
                plots: {
                  id: {
                    _eq: this.plotId
                  }
                }
              }
            }
          }
        }
        if (this.plotGeometry != null) {
          whereClause.geometry = { _st_intersects: this.plotGeometry }
        }
        return {
          where: whereClause
        }
      }
    }
  },
  computed: {
    loading () {
      return !this.soilSites && this.$apollo.queries.soilSites.loading
    }
  },
  methods: {
    onEditSoilSite (soilSite) {
      this.$router.push({ name: 'holdingSoilSiteEdit', params: { soilSiteId: soilSite.id } })
    },
    onNewSoilSite () {
      const params = {}
      if (this.plotId !== null) {
        params.plotId = this.plotId
      }
      this.$router.push({ name: 'holdingSoilSiteCreate', params })
    }
  }
}

</script>
